## Python Library: falwa (v2.3.3)

[![Python package](https://github.com/csyhuang/hn2016_falwa/actions/workflows/python-build-test.yml/badge.svg)](https://github.com/csyhuang/hn2016_falwa/actions/workflows/python-build-test.yml)[![codecov.io](https://codecov.io/gh/csyhuang/hn2016_falwa/branch/master/graph/badge.svg)](https://codecov.io/gh/csyhuang/hn2016_falwa)[![Documentation Status](https://readthedocs.org/projects/hn2016-falwa/badge/?version=latest)](http://hn2016-falwa.readthedocs.io/en/latest/?badge=latest)[![DOI](https://zenodo.org/badge/63908662.svg)](https://zenodo.org/badge/latestdoi/63908662)

**Important:** this python package has been renamed from `hn2016_falwa` to `falwa` since version v1.0.0.

![hn2016_falwa_diagram](https://github.com/csyhuang/csyhuang.github.io/blob/master/assets/img/falwa_diagram.png)

Compute from gridded climate data the Finite-amplitude Local Wave Activity (FALWA) and flux terms presented in:

- [Huang and Nakamura (2016, JAS)](http://dx.doi.org/10.1175/JAS-D-15-0194.1)
- [Huang and Nakamura (2017, GRL)](http://onlinelibrary.wiley.com/doi/10.1002/2017GL073760/full).
- [Nakamura and Huang (2018, Science)](https://doi.org/10.1126/science.aat0721) *Atmospheric Blocking as a Traffic Jam in the Jet Stream*.
- [Neal et al (2022, GRL)](https://agupubs.onlinelibrary.wiley.com/doi/10.1029/2021GL097699) *The 2021 Pacific Northwest Heat Wave and Associated Blocking: Meteorology and the Role of an Upstream Cyclone as a Diabatic Source of Wave Activity*.
- [Lubis et al (2025, Nature Comm)](https://www.nature.com/articles/s41467-025-64672-9). *Cloud-Radiative Effects Significantly Increase Wintertime Atmospheric Blocking in the Euro-Atlantic Sector*.

## Citing this package

We would be grateful if you mention `falwa` and cite our [software package paper](https://rmets.onlinelibrary.wiley.com/doi/full/10.1002/gdj3.70006) published in the Geoscience Data Journal upon usage:

> Huang, C. S. Y., Polster, C., & Nakamura, N. (2025). **Falwa: Python Package to Implement Finite‐Amplitude Local Wave Activity Diagnostics on Climate Data**. *Geoscience Data Journal, 12*(2), e70006.

```
@article{huang_polster_nakamura_2025,
  title={Falwa: Python Package to Implement Finite-Amplitude Local Wave Activity Diagnostics on Climate Data},
  author={Huang, Clare S Y and Polster, Christopher and Nakamura, Noboru},
  journal={Geoscience Data Journal},
  volume={12},
  number={2},
  pages={e70006},
  year={2025},
  doi = {10.1002/GDJ3.70006},
  publisher={Wiley Online Library}}
```

## Package Installation

**Attention: substantial changes took place in release v2.0.0. Installation in develop mode is no longer available.**

Since release v2.0.0, the F2PY modules in `falwa` is compiled with `meson` (See Issue #95 for details) to cope with the deprecation of `numpy.disutils` in python 3.12. 

### First-time installation

1. To build the package from source, you need a fortran compiler (e.g., [gfortran](http://hpc.sourceforge.net/)) to implement the installation.
2. Clone the package repo by `git clone https://github.com/csyhuang/hn2016_falwa.git` .
3. Navigate into the repository and set up a python environment satisfying the installation requirement by `conda env create -f environment.yml`. The environment name in the file is set to be `falwa_env` (which users can change).
4. Install the package with the command `python -m pip install .`. The compile modules will be saved to python site-packages directory.
5. If the installation is successful, you should be able to run through all unit tests in the folder `tests/` by executing `pytest tests/`.

### Get updated code from new releases

1. To incorporate updates, first, pull the new version of the code from GitHub by `git pull`.
2. Uninstall existing version of `falwa`: `pip uninstall falwa`
3. If there is change in `environment.yml`, remove the existing environment by `conda remove --name falwa_env --all` and create the environment again from the updated YML file: `conda env create -f environment.yml`.
4. Reinstall the updated version by `python -m pip install .`.
5. Run through all unit tests in the folder `tests/` by executing `pytest tests/` to make sure the package has been properly installed.

## Quick start

There are some readily run python scripts (in `scripts/`) and jupyter notebooks (in `notebooks/`) which you can start with. 
The netCDF files needed can be found in [Clare's Dropbox folder](https://www.dropbox.com/scl/fo/b84pwlr7zzsndq8mpthd8/AKMmwRiYhK4mRmdOgmFg5SM?rlkey=k15p1acgksnl2xwcxve3alm0u&st=2mg4svks&dl=0).

Depending on what you want to do, the methods to be use may be different.

1. If you solely want to compute equivalent latitude and local wave activity from a 2D field, you can refer to `notebooks/simple/Example_barotropic.ipynb`. This is useful for users who want to use LWA to quantify field anomalies.

2. If you want to compute zonal wind reference states and wave activity fluxes in QG Formalism, look at `notebooks/nh2018_science/demo_script_for_nh2018.ipynb` for the usage of `QGField`. This notebook demonstrates how to compute wave activity and reference states presented in Nakamura and Huang (2018). To make sure the package is properly installed in your environment, run through the notebook after installation to see if there is error.

## Inquiries / Issues reporting

- If you are interested in getting email message related to update of this package, please leave your contact [here](https://goo.gl/forms/5L8fv0mUordugq6v2) such that I can keep you updated of any changes made.
- If you encounter *coding issues/bugs* when using the package, please create an [Issue ticket](https://github.com/csyhuang/hn2016_falwa/issues).
- If you have scientific questions, please create a thread in the [Discussion Board](https://github.com/csyhuang/hn2016_falwa/discussions) with the category "General" or "Q&A" according to the circumstance.

SUBROUTINE matrix_after_inversion(k,kmax,jd,qjj,djj,cjj,rj,sjk,tjk)

  INTEGER, INTENT(in) :: k, kmax, jd
  REAL, INTENT(in) :: qjj(jd-2,jd-2),djj(jd-2,jd-2),cjj(jd-2,jd-2),rj(jd-2)
  REAL, INTENT(INOUT) :: sjk(jd-2,jd-2,kmax-1),tjk(jd-2,kmax-1)  ! Note that tj is not used in subsequent modules

  integer :: i, j
  real :: xjj(jd-2,jd-2),yj(jd-2),tj(jd-2)

  tj(:) = tjk(:,k)
  do i = 1,jd-2
    do j = 1,jd-2
    xjj(i,j) = 0.
    do kk = 1,jd-2
      xjj(i,j) = xjj(i,j)+qjj(i,kk)*djj(kk,j)
    enddo
    sjk(i,j,k-1) = -xjj(i,j)
    enddo
  enddo

  !  **** Evaluate rk - Ck Tk ****
  do i = 1,jd-2
    yj(i) = 0.
    do kk = 1,jd-2
      yj(i) = yj(i)+cjj(i,kk)*tj(kk)
    enddo
    yj(i) =  rj(i)-yj(i)
  enddo

  ! ***** Evaluate Eq. 23 *******
  do i = 1,jd-2
    tj(i) = 0.
    do kk = 1,jd-2
      tj(i) = tj(i)+qjj(i,kk)*yj(kk)
    enddo
    tjk(i,k-1) = tj(i)
  enddo

END SUBROUTINE matrix_after_inversion

SUBROUTINE upward_sweep(jmax, kmax, nd, jb, jd, sjk, tjk, ckref, tb, qref_over_cor, tref, qref, u, a, om, dz, h, rr, cp)

  INTEGER, INTENT(IN) :: jmax, kmax, nd, jb, jd
  REAL, INTENT(IN) :: sjk(jd-2,jd-2,kmax-1),tjk(jd-2,kmax-1),ckref(nd,kmax),tb(kmax),qref_over_cor(nd,kmax)
  REAL, INTENT(IN) :: a, om, dz, h, rr, cp
  REAL, INTENT(OUT) :: qref(nd,kmax), tref(jd,kmax), u(jd,kmax)
  real :: tg(kmax)
  real :: pjk(jd-2,kmax)
  real :: tj(jd-2)
  real :: yj(jd-2)
  real :: sjj(jd-2,jd-2)
  real :: pj(jd-2)

  rkappa = rr/cp
  pi = acos(-1.)
  dp = pi/float(jmax-1)


  pjk(:,1) = 0.
  do k = 1,kmax-1
    pj(:) = pjk(:,k)
    sjj(:,:) = sjk(:,:,k)
    tj(:) = tjk(:,k)

    do i = 1,jd-2
      yj(i) = 0.
      do kk = 1,jd-2
        yj(i) = yj(i)+sjj(i,kk)*pj(kk)
      enddo
      pjk(i,k+1) = yj(i)+tj(i)
    enddo
    !        call gemv(sjj,pj,yj)
    !        pjk(:,k+1) = yj(:) + tj(:)
  enddo

  ! **** Recover u *****
  do k = 1,kmax
    do j = 2,jd-1
      u(j,k) = pjk(j-1,k)
    enddo
  enddo

  ! *** Corner boundary conditions ***
  u(1,1) = 0.
  u(jd,1) = 0.
  !        u(1,kmax) = ubar(1+jb,kmax)*cos(dp*float(jb))
  u(1,kmax) = ckref(1+jb,kmax)/(2.*pi*a)-om*a*cos(dp*float(jb))
  u(jd,kmax) = 0.

  ! *** Divide by cos phi to recover Uref ****
  do jj = jb+1,nd-1
    j = jj-jb
    phi0 = dp*float(jj-1)
    u(j,:) = u(j,:)/cos(phi0)
  enddo
  u(jd,:) = 2.*u(jd-1,:)-u(jd-2,:)

  ! ******** compute tref *******
  qref(:, :) = qref_over_cor(:, :)  ! modify for f2py wrapping purpose
  do k = 2,kmax-1
    t00 = 0.
    zz = dz*float(k-1)
    tref(1,k) = t00
    tref(2,k) = t00
    do j = 2,jd-1
      phi0 = dp*float(j-1+jb)
      cor = 2.*om*sin(phi0)
      uz = (u(j,k+1)-u(j,k-1))/(2.*dz)
      ty = -cor*uz*a*h*exp(rkappa*zz/h)
      ty = ty/rr
      tref(j+1,k) = tref(j-1,k)+2.*ty*dp
    enddo
    do j = 1,nd
      phi0 = dp*float(j-1)
      qref(j,k) = qref_over_cor(j,k)*sin(phi0)
    enddo

    tg(k) = 0.
    wt = 0.
    do jj = jb+1,nd
      j = jj-jb
      phi0 = dp*float(jj-1)
      tg(k) = tg(k)+cos(phi0)*tref(j,k)
      wt = wt + cos(phi0)
    enddo
    tg(k) = tg(k)/wt
    tres = tb(k)-tg(k)
    tref(:,k) = tref(:,k)+tres
  enddo
  tref(:,1) = tref(:,2)-tb(2)+tb(1)
  tref(:,kmax) = tref(:,kmax-1)-tb(kmax-1)+tb(kmax)

END SUBROUTINE upward_sweep

SUBROUTINE compute_qgpv(nlon, nlat, kmax, ut, vt, theta, height, t0, stat, &
                        aa, omega, dz, hh, rr, cp, &
                        pv, avort)

   
    INTEGER, INTENT(IN) :: nlon, nlat, kmax
    REAL, INTENT(IN) :: ut(nlon,nlat,kmax), vt(nlon,nlat,kmax), theta(nlon,nlat,kmax), &
                        height(kmax), t0(kmax), stat(kmax)
    REAL, INTENT(in) :: aa, omega, hh, rr, cp
    REAL, INTENT(out) :: pv(nlon,nlat,kmax), avort(nlon,nlat,kmax)


    REAL ::  tz(nlat,kmax),tzd(nlat,kmax)
    REAL ::  uz(nlat,kmax),uzd(nlat,kmax)
    REAL ::  vz(nlat,kmax),vzd(nlat,kmax)
    REAL ::  st(nlon,nlat),zmst(nlat)
    REAL ::  zmav(nlat,kmax)
    REAL ::  zmpv(nlat,kmax)
    REAL :: rkappa, pi, dphi


    rkappa = rr/cp
    pi = acos(-1.)
    dphi = pi/float(nlat-1)

    !  **** compute zonal mean ****
    tz = 0.
    uz = 0.
    vz = 0.

    tzd = 0.
    uzd = 0.
    vzd = 0.


    do j = 1,nlat
        do k = 1,kmax
            do i = 1,nlon
                tzd(j,k) = tzd(j,k) + theta(i,j,k)/float(nlon)
                uzd(j,k) = uzd(j,k) + ut(i,j,k)/float(nlon)
                vzd(j,k) = vzd(j,k) + vt(i,j,k)/float(nlon)
                tz(j,k) = tz(j,k)+theta(i,j,k)/(float(nlon))
                uz(j,k) = uz(j,k)+ut(i,j,k)/(float(nlon))
                vz(j,k) = vz(j,k)+vt(i,j,k)/(float(nlon))
            enddo
        enddo
    enddo

    ! surface temp
    do j = 1,nlat
        zmst(j) = 0.
        do i = 1,nlon
            zmst(j) = zmst(j) + st(i,j)/float(nlon)
        enddo
    enddo

    ! interior abs. vort

    do kk = 1,kmax
        do j = 2,nlat-1
            phi0 = -90.+float(j-1)*180./float(nlat-1)
            phi0 = phi0*pi/180.
            phim = -90.+float(j-2)*180./float(nlat-1)
            phim = phim*pi/180.
            phip = -90.+float(j)*180./float(nlat-1)
            phip = phip*pi/180.

            do i = 2,nlon-1
                av1 = 2.*omega*sin(phi0)
                av2 = (vt(i+1,j,kk)-vt(i-1,j,kk))/(2.*aa*cos(phi0)*dphi)
                av3 = -(ut(i,j+1,kk)*cos(phip)-ut(i,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)  
                avort(i,j,kk) = av1+av2+av3
            enddo

            av1 = 2.*omega*sin(phi0)
            av2 = (vt(2,j,kk)-vt(nlon,j,kk))/(2.*aa*cos(phi0)*dphi)
            av3 = -(ut(1,j+1,kk)*cos(phip)-ut(1,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)  
            avort(1,j,kk) = av1+av2+av3
            av4 = 2.*omega*sin(phi0)
            av5 = (vt(1,j,kk)-vt(nlon-1,j,kk))/(2.*aa*cos(phi0)*dphi)
            av6 =   & 
            -(ut(nlon,j+1,kk)*cos(phip)-ut(nlon,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
            avort(nlon,j,kk) = av4+av5+av6
        enddo

        avs = 0.
        avn = 0.
        do i = 1,nlon
            avs = avs + avort(i,2,kk)/float(nlon)
            avn = avn + avort(i,nlat-1,kk)/float(nlon)
        enddo
        avort(:,1,kk) = avs
        avort(:,nlat,kk) = avn
    enddo

    ! zonal mean vort

    do kk = 1,kmax
        do j = 1,nlat
            zmav(j,kk) = 0.
            do i = 1,nlon
                zmav(j,kk) = zmav(j,kk)+avort(i,j,kk)/float(nlon)
            enddo
        enddo
    enddo

    ! interior pv

    do kk = 2,kmax-1
        do j = 1,nlat
            phi0 = -90.+float(j-1)*180./float(nlat-1)
            phi0 = phi0*pi/180.
            f = 2.*omega*sin(phi0)
            do i = 1,nlon
                altp = exp(-height(kk+1)/hh)*(theta(i,j,kk+1)-t0(kk+1))/stat(kk+1)
                altm = exp(-height(kk-1)/hh)*(theta(i,j,kk-1)-t0(kk-1))/stat(kk-1)
                altp = altp
                altm = altm
                strc = (altp-altm)*zmav(j,kk)/(height(kk+1)-height(kk-1))
                !     strc = (altp-altm)*f/(height(kk+1)-height(kk-1))
                pv(i,j,kk) = avort(i,j,kk) + exp(height(kk)/hh)*strc
            enddo
        enddo
    enddo

    ! zonal mean pv

    do kk = 1,kmax
        do j = 1,nlat
            zmpv(j,kk) = 0.
            do i = 1,nlon
                zmpv(j,kk) = zmpv(j,kk)+pv(i,j,kk)/float(nlon)
            enddo
        enddo
    enddo

END SUBROUTINE

SUBROUTINE compute_lwa_and_barotropic_fluxes(nlon, nlat, kmax, jd, &
                          pv,uu,vv,pt,qref,uref,tref,&
                         a, om, dz, h, r, cp, prefactor, &
                         astar,astarbaro,ua1baro,ubaro,ua2baro,ep1baro,ep2baro,ep3baro,ep4)

    implicit none

    integer, intent(in) :: nlon, nlat, kmax, jd
    real, intent(in) :: pv(nlon,nlat,kmax),uu(nlon,nlat,kmax),vv(nlon,nlat,kmax), &
                        pt(nlon,nlat,kmax),qref(jd,kmax),uref(jd,kmax),tref(jd,kmax)
    real, intent(in) ::  a, om, dz, h, r, cp, prefactor
    real, intent(out) :: astar(nlon,jd,kmax),astarbaro(nlon,jd),ua1baro(nlon,jd),ubaro(nlon,jd),&
                         ua2baro(nlon,jd),ep1baro(nlon,jd),ep2baro(nlon,jd),ep3baro(nlon,jd),ep4(nlon,jd)
    ! === dummy variables ===
    integer :: i, j, jj, k
    real :: qe(nlon,nlat),ue(nlon,nlat)
    real :: ua1(nlon,jd,kmax)
    real :: ua2(nlon,jd,kmax),ep1(nlon,jd,kmax)
    real :: ep2(nlon,jd,kmax),ep3(nlon,jd,kmax)
    real :: tg(kmax)
    real :: aa, ab, cor, dc, ep11, ep41, ep42, ep43, wt, zk, zz, dp, rkappa
    real :: cosphi(0:jd+1), sinphi(0:jd+1)
    real, parameter :: pi = acos(-1.)

    dp = pi/float(nlat-1)
    rkappa = r/cp

    ! cos and sin of latitude are often used in the following computations.
    ! Because the evaluation of trigonometric functions is computationally
    ! expensive, values are computed once here and stored for later.
    cosphi(0) = cos(0.) ! fill values for meridional
    sinphi(0) = sin(0.) !  heat flux computation
    do j=1,jd+1
        cosphi(j) = cos(dp*float(j-1))
        sinphi(j) = sin(dp*float(j-1))
    enddo

    ! **** hemispheric-mean potential temperature ****

    tg(:) = 0.              ! mean PT
    wt = 0.                 ! area weight
    do j = 1,jd             ! NH
        tg(:) = tg(:)+cosphi(j)*tref(j,:)
        wt = wt + cosphi(j)
    enddo
    tg(:) = tg(:)/wt       ! averaging

    ! **** wave activity and nonlinear zonal flux F2 ****

    do k = 2,kmax-1
        do i = 1,nlon
            do j = 1,jd-1            ! 13.5N and higher latitude
                astar(i,j,k) = 0.       ! LWA*cos(phi)
                ua2(i,j,k) = 0.         ! F2
                cor = 2.*om*sinphi(j)          !Coriolis parameter
                ab = a*dp !constant length element
                ! South of the current latitude
                do jj = 1,j-1
                    qe(i,jj) = pv(i,jj+jd-1,k)-qref(j,k)*cor   !qe; Q = qref*cor
                    ue(i,jj) = uu(i,jj+jd-1,k)*cosphi(j)-uref(j,k)*cosphi(jj)       !ue
                    aa = a*dp*cosphi(jj)                       !length element
                    if(qe(i,jj).gt.0.) then                    !LWA*cos(phi) and F2
                        astar(i,j,k)=astar(i,j,k)+qe(i,jj)*aa
                        ua2(i,j,k) = ua2(i,j,k)+qe(i,jj)*ue(i,jj)*ab
                    endif  
                enddo
                ! North of the current latitude
                do jj = j,jd
                    qe(i,jj) = pv(i,jj+jd-1,k)-qref(j,k)*cor   !qe; Q = qref*cor
                    ue(i,jj) = uu(i,jj+jd-1,k)*cosphi(j)-uref(j,k)*cosphi(jj)       !ue
                    aa = a*dp*cosphi(jj)                       !length element
                    if(qe(i,jj).le.0.) then                    !LWA*cos(phi) and F2
                        astar(i,j,k)=astar(i,j,k)-qe(i,jj)*aa
                        ua2(i,j,k) = ua2(i,j,k)-qe(i,jj)*ue(i,jj)*ab
                    endif  
                enddo

                !    *********  Other fluxes *********

                ua1(i,j,k) = uref(j,k)*astar(i,j,k)            !F1     
                ep1(i,j,k) = -0.5*(uu(i,j+jd-1,k)-uref(j,k))**2  !F3a
                ep1(i,j,k) = ep1(i,j,k)+0.5*vv(i,j+jd-1,k)**2    !F3a+b
                ep11 = 0.5*(pt(i,j+jd-1,k)-tref(j,k))**2         !F3c
                zz = dz*float(k-1)
                ep11 = ep11*(r/h)*exp(-rkappa*zz/h)
                ep11 = ep11*2.*dz/(tg(k+1)-tg(k-1))
                ep1(i,j,k) = ep1(i,j,k)-ep11                   !F3
                ep1(i,j,k) = ep1(i,j,k)*cosphi(j) ! correct for cosine factor

                ! meridional eddy momentum flux one grid north and south
                if (j.gt.1) then  ! only compute ep2 and ep3 for interior points (on latitude grid)
                    ep2(i,j,k) = (uu(i,j+jd,k)-uref(j+1,k))*cosphi(j+1)*cosphi(j+1) * vv(i,j+jd,k)
                    ep3(i,j,k) = (uu(i,j+jd-2,k)-uref(j-1,k))*cosphi(j-1)*cosphi(j-1) * vv(i,j+jd-2,k)
                end if

                ! low-level meridional eddy heat flux
                if(k.eq.2) then     ! (26) of SI-HN17
                    ep41 = 2.*om*sinphi(j)*cosphi(j)*dz/prefactor       ! prefactor
                    ep42 = exp(-dz/h)*vv(i,j+jd-1,2)*(pt(i,j+jd-1,2)-tref(j,2))
                    ep42 = ep42/(tg(3)-tg(1))
                    ep43 = vv(i,j+jd-1,1)*(pt(i,j+jd-1,1)-tref(j,1))
                    ep43 = 0.5*ep43/(tg(2)-tg(1))
                    ep4(i,j) = ep41*(ep42+ep43)   ! low-level heat flux
                endif
            enddo
        enddo
    enddo

    ! ******** Column average: (25) of SI-HN17 ********

    astarbaro(:,:) = 0.
    ubaro(:,:) = 0.
    ua1baro(:,:) = 0.
    ua2baro(:,:) = 0.
    ep1baro(:,:) = 0.
    ep2baro(:,:) = 0.
    ep3baro(:,:) = 0.
    dc = dz/prefactor

    do k = 2,kmax-1
        zk = dz*float(k-1)
        astarbaro(:,:) = astarbaro(:,:)+astar(:,:,k)*exp(-zk/h)*dc
        ua1baro(:,:) = ua1baro(:,:)+ua1(:,:,k)*exp(-zk/h)*dc
        ua2baro(:,:) = ua2baro(:,:)+ua2(:,:,k)*exp(-zk/h)*dc
        ep1baro(:,:) = ep1baro(:,:)+ep1(:,:,k)*exp(-zk/h)*dc
        ep2baro(:,:) = ep2baro(:,:)+ep2(:,:,k)*exp(-zk/h)*dc
        ep3baro(:,:) = ep3baro(:,:)+ep3(:,:,k)*exp(-zk/h)*dc
        do j = 1,jd  ! ### yet to be multiplied by cosine
            ubaro(:,j) = ubaro(:,j)+uu(:,j+jd-1,k)*exp(-zk/h)*dc
        enddo
    enddo


end subroutine

SUBROUTINE interpolate_fields(nlon, nlat, nlev, kmax, uu, vv, temp, plev, height, &
                              aa, omega, dz, hh, rr, cp, pv, ut, vt, avort, theta, stat)

   
    INTEGER, INTENT(IN) :: nlon, nlat, nlev, kmax
    REAL, INTENT(IN) :: uu(nlon,nlat,nlev), vv(nlon,nlat,nlev), temp(nlon,nlat,nlev), &
                        plev(nlev), height(kmax)
    REAL, INTENT(in) :: aa, omega, hh, rr, cp
    REAL, INTENT(out) :: pv(nlon,nlat,kmax), ut(nlon,nlat,kmax), vt(nlon,nlat,kmax), avort(nlon,nlat,kmax)
    REAL, INTENT(out) :: theta(nlon,nlat,kmax), stat(kmax)


    REAL ::  tt(nlon,nlat,nlev),tz(nlat,kmax),tzd(nlat,kmax)
    REAL ::  uz(nlat,kmax),uzd(nlat,kmax)
    REAL ::  vz(nlat,kmax),vzd(nlat,kmax)
    REAL ::  t0(kmax),zlev(nlev)
    REAL ::  st(nlon,nlat),zmst(nlat)
    REAL ::  zmav(nlat,kmax)
    REAL ::  zmpv(nlat,kmax)
    REAL :: rkappa, pi, dphi


    rkappa = rr/cp
    pi = acos(-1.)
    dphi = pi/float(nlat-1)


    ! ====  vertical interpolation ====
    do k = 1,nlev
        zlev(k) = -hh*alog(plev(k)/1000.)
    enddo

    do i = 1,nlon
        do j = 1,nlat

            do k = 1,nlev
                tt(i,j,k) = temp(i,j,k)*((1000./plev(k))**rkappa)
            enddo



            st(i,j) = tt(i,j,1)      ! surface pot. temp

            do kk = 1,kmax   ! vertical interpolation 
                ttt = height(kk)
                do k = 1,nlev-1
                    tt2 = zlev(k+1)
                    tt1 = zlev(k)
                    if((ttt.ge.tt1).and.(ttt.lt.tt2)) then
                        dd1 = (ttt-tt1)/(tt2-tt1)
                        dd2 = 1.-dd1
                        theta(i,j,kk) = tt(i,j,k)*dd2 + tt(i,j,k+1)*dd1
                        ut(i,j,kk) = uu(i,j,k)*dd2 + uu(i,j,k+1)*dd1
                        vt(i,j,kk) = vv(i,j,k)*dd2 + vv(i,j,k+1)*dd1
                        goto 348
                    endif
                enddo
                348 continue
            enddo
        enddo
    enddo

    !  **** compute zonal mean ****
    tz = 0.
    uz = 0.
    vz = 0.

    tzd = 0.
    uzd = 0.
    vzd = 0.


    do j = 1,nlat
        do k = 1,kmax
            do i = 1,nlon
                tzd(j,k) = tzd(j,k) + theta(i,j,k)/float(nlon)
                uzd(j,k) = uzd(j,k) + ut(i,j,k)/float(nlon)
                vzd(j,k) = vzd(j,k) + vt(i,j,k)/float(nlon)
                tz(j,k) = tz(j,k)+theta(i,j,k)/(float(nlon))
                uz(j,k) = uz(j,k)+ut(i,j,k)/(float(nlon))
                vz(j,k) = vz(j,k)+vt(i,j,k)/(float(nlon))
            enddo
        enddo
    enddo


    ! reference theta
    do kk = 1,kmax
        t0(kk) = 0.
        csm = 0.
        do j = 1,nlat
            phi0 = -90.+float(j-1)*180./float(nlat-1)
            phi0 = phi0*pi/180.
            t0(kk) = t0(kk) + tzd(j,kk)*cos(phi0)
            csm = csm + cos(phi0)
        enddo
        t0(kk) = t0(kk)/csm
    enddo

    ! static stability
    do kk = 2,kmax-1
        stat(kk) = (t0(kk+1)-t0(kk-1))/(height(kk+1)-height(kk-1))
    enddo
    stat(kmax) = (t0(kmax)-t0(kmax-1))/(height(kmax)-height(kmax-1))
    stat(1) = (t0(2)-t0(1))/(height(2)-height(1))


    ! surface temp

    do j = 1,nlat
        zmst(j) = 0.
        do i = 1,nlon
            zmst(j) = zmst(j) + st(i,j)/float(nlon)
        enddo
    enddo

    ! interior abs. vort

    do kk = 1,kmax
        do j = 2,nlat-1
            phi0 = -90.+float(j-1)*180./float(nlat-1)
            phi0 = phi0*pi/180.
            phim = -90.+float(j-2)*180./float(nlat-1)
            phim = phim*pi/180.
            phip = -90.+float(j)*180./float(nlat-1)
            phip = phip*pi/180.

            do i = 2,nlon-1
                av1 = 2.*omega*sin(phi0)
                av2 = (vt(i+1,j,kk)-vt(i-1,j,kk))/(2.*aa*cos(phi0)*dphi)
                av3 = -(ut(i,j+1,kk)*cos(phip)-ut(i,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)  
                avort(i,j,kk) = av1+av2+av3
            enddo

            av1 = 2.*omega*sin(phi0)
            av2 = (vt(2,j,kk)-vt(nlon,j,kk))/(2.*aa*cos(phi0)*dphi)
            av3 = -(ut(1,j+1,kk)*cos(phip)-ut(1,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)  
            avort(1,j,kk) = av1+av2+av3
            av4 = 2.*omega*sin(phi0)
            av5 = (vt(1,j,kk)-vt(nlon-1,j,kk))/(2.*aa*cos(phi0)*dphi)
            av6 =   & 
            -(ut(nlon,j+1,kk)*cos(phip)-ut(nlon,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
            avort(nlon,j,kk) = av4+av5+av6
        enddo

        avs = 0.
        avn = 0.
        do i = 1,nlon
            avs = avs + avort(i,2,kk)/float(nlon)
            avn = avn + avort(i,nlat-1,kk)/float(nlon)
        enddo
        avort(:,1,kk) = avs
        avort(:,nlat,kk) = avn
    enddo

    ! zonal mean vort

    do kk = 1,kmax
        do j = 1,nlat
            zmav(j,kk) = 0.
            do i = 1,nlon
                zmav(j,kk) = zmav(j,kk)+avort(i,j,kk)/float(nlon)
            enddo
        enddo
    enddo

    ! interior pv

    do kk = 2,kmax-1
        do j = 1,nlat
            phi0 = -90.+float(j-1)*180./float(nlat-1)
            phi0 = phi0*pi/180.
            f = 2.*omega*sin(phi0)
            do i = 1,nlon
                altp = exp(-height(kk+1)/hh)*(theta(i,j,kk+1)-t0(kk+1))/stat(kk+1)
                altm = exp(-height(kk-1)/hh)*(theta(i,j,kk-1)-t0(kk-1))/stat(kk-1)
                altp = altp
                altm = altm
                strc = (altp-altm)*zmav(j,kk)/(height(kk+1)-height(kk-1))
                !     strc = (altp-altm)*f/(height(kk+1)-height(kk-1))
                pv(i,j,kk) = avort(i,j,kk) + exp(height(kk)/hh)*strc
            enddo
        enddo
    enddo

    ! zonal mean pv

    do kk = 1,kmax
        do j = 1,nlat
            zmpv(j,kk) = 0.
            do i = 1,nlon
                zmpv(j,kk) = zmpv(j,kk)+pv(i,j,kk)/float(nlon)
            enddo
        enddo
    enddo


!     write(6,*) 'U ',maxval(uz),minval(uz)
!     write(6,*) 'V ',maxval(vz),minval(vz)
!     write(6,*) 'T ',maxval(tz),minval(tz)    
!     write(6,*) 'AVORT',maxval(avort),minval(avort)    
!     write(6,*) 'PV ',maxval(zmpv),minval(zmpv)
!     write(6,*) 'zmpv', sum(zmpv, dim=1)

END SUBROUTINE

SUBROUTINE compute_qgpv_direct_inv(nlon, nlat, kmax, jd, uq, vq, tq, height, &
        ts0, tn0, stats, statn, &
        aa, omega, dz, hh, rr, cp, &
        pv, avort)


  INTEGER, INTENT(IN) :: nlon, nlat, kmax, jd
  REAL, INTENT(IN) :: uq(nlon,nlat,kmax), vq(nlon,nlat,kmax), tq(nlon,nlat,kmax), height(kmax)
  REAL, INTENT(in) :: stats(kmax), statn(kmax), ts0(kmax), tn0(kmax)
  REAL, INTENT(in) :: aa, omega, dz,  hh, rr, cp
  REAL, INTENT(out) :: pv(nlon,nlat,kmax), avort(nlon,nlat,kmax)

   real ::  tzd(nlat,kmax)
   !real ::  st(nlon,nlat),zmst(nlat)
   real ::  zmav(nlat,kmax)
   real ::  zmpv(nlat,kmax)
   integer :: k0(kmax),kp(kmax)

   rkappa = rr/cp
   pi = acos(-1.)
   dphi = pi/float(nlat-1)

  write(6,*) 'nlon, nlat, kmax, jd'
  write(6,*) nlon, nlat, kmax, jd

  ! interior abs. vort

  do kk = 1,kmax
    do j = 2,nlat-1
      phi0 = -0.5*pi + pi*float(j-1)/float(nlat-1)
      phim = -0.5*pi + pi*float(j-2)/float(nlat-1)
      phip = -0.5*pi + pi*float(j)/float(nlat-1)

      do i = 2,nlon-1
        av1 = 2.*omega*sin(phi0)
        av2 = (vq(i+1,j,kk)-vq(i-1,j,kk))/(2.*aa*cos(phi0)*dphi)
        av3 = -(uq(i,j+1,kk)*cos(phip)-uq(i,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
        avort(i,j,kk) = av1+av2+av3
      enddo

      av1 = 2.*omega*sin(phi0)
      av2 = (vq(2,j,kk)-vq(nlon,j,kk))/(2.*aa*cos(phi0)*dphi)
      av3 = -(uq(1,j+1,kk)*cos(phip)-uq(1,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
      avort(1,j,kk) = av1+av2+av3
      av4 = 2.*omega*sin(phi0)
      av5 = (vq(1,j,kk)-vq(nlon-1,j,kk))/(2.*aa*cos(phi0)*dphi)
      av6 =   &
      -(uq(nlon,j+1,kk)*cos(phip)-uq(nlon,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
      avort(nlon,j,kk) = av4+av5+av6
    enddo

    avs = 0.
    avn = 0.
    do i = 1,nlon
      avs = avs + avort(i,2,kk)/float(nlon)
      avn = avn + avort(i,nlat-1,kk)/float(nlon)
    enddo
    avort(:,1,kk) = avs
    avort(:,nlat,kk) = avn
  enddo

  ! zonal mean vort

  do kk = 1,kmax
    do j = 1,nlat
      zmav(j,kk) = 0.
      do i = 1,nlon
        zmav(j,kk) = zmav(j,kk)+avort(i,j,kk)/float(nlon)
      enddo
    enddo
  enddo

  ! interior pv

  do kk = 2,kmax-1
    do j = 1,nlat
      phi0 = -0.5*pi + pi*float(j-1)/float(nlat-1)
      f = 2.*omega*sin(phi0)
      if (j .le. jd) then
        statp = stats(kk+1)
        statm = stats(kk-1)
        t00p = ts0(kk+1)
        t00m = ts0(kk-1)
      else
        statp = statn(kk+1)
        statm = statn(kk-1)
        t00p = tn0(kk+1)
        t00m = tn0(kk-1)
      endif

      do i = 1,nlon
        thetap = tq(i,j,kk+1)
        thetam = tq(i,j,kk-1)
        altp = exp(-height(kk+1)/hh)*(thetap-t00p)/statp
        altm = exp(-height(kk-1)/hh)*(thetam-t00m)/statm
        strc = (altp-altm)*f/(height(kk+1)-height(kk-1))
        pv(i,j,kk) = avort(i,j,kk) + exp(height(kk)/hh)*strc
      enddo
    enddo
  enddo

! zonal mean pv

  do kk = 1,kmax
    do j = 1,nlat
      zmpv(j,kk) = 0.
      do i = 1,nlon
        zmpv(j,kk) = zmpv(j,kk)+pv(i,j,kk)/float(nlon)
      enddo
    enddo
  enddo
END SUBROUTINE

SUBROUTINE compute_qref_and_fawa_first(pv, uu, vort, pt, tn0, imax, JMAX, kmax, nd, nnd, jb, jd, &
        a, omega, dz, h, dphi, dlambda, rr, cp, &
        qref, ubar, tbar, fawa, ckref, tjk, sjk)


  !USE mkl95_LAPACK, ONLY: GETRF,GETRI

  REAL, INTENT(IN) :: pv(imax,jmax,kmax),uu(imax,jmax,kmax),vort(imax,jmax,kmax),pt(imax,jmax,kmax),tn0(kmax)
  INTEGER, INTENT(IN) :: imax, JMAX, kmax, nd, nnd, jb, jd
  REAL, INTENT(in) :: a, omega, dz, h, dphi, dlambda, rr, cp
  REAL, INTENT(OUT) :: qref(nd,kmax),ubar(nd,kmax),tbar(nd,kmax),fawa(nd,kmax),ckref(nd,kmax),&
          tjk(jd-2,kmax-1),sjk(jd-2,jd-2,kmax-1)

  !   **** take QG analysis and compute Q_ref and invert for U_ref & Theta_ref for NH (Direct solver) ***

  !integer,parameter :: imax = 360, JMAX = 181, KMAX = 97
  !integer,parameter :: nd = 91,nnd=181
  !integer,parameter :: jb = 5   ! lower bounding latitude
  !integer,parameter :: jd = 86  ! nd - lower bounding latitude

  REAL :: pv2(imax,jmax)
  REAL :: vort2(imax,jmax)
  REAL :: qn(nnd),an(nnd),aan(nnd),tb(kmax)
  REAL :: cn(nnd),ccn(nnd),cref(nd,kmax)
  REAL :: alat(nd),phi(nd),z(kmax),cbar(nd,kmax)
  REAL :: qbar(nd,kmax)

  pi = acos(-1.)
  !dphi = pi/float(jmax-1)  !!!  This is dlat
  !dlambda = 2*pi/float(imax)  !!!! pragallva- correction added on Dec 13, 2023. This is dlon
  rkappa = rr/cp

  do nn = 1,nd
    phi(nn) = dphi*float(nn-1)
    alat(nn) = 2.*pi*a*a*(1.-sin(phi(nn)))
  enddo

  do k = 1,kmax
    z(k) = dz*float(k-1)
  enddo


  ! **** Zonal-mean field ****
  do j = nd,jmax
    qbar(j-(nd-1),:) = 0.
    tbar(j-(nd-1),:) = 0.
    ubar(j-(nd-1),:) = 0.
    do i = 1,imax
      qbar(j-(nd-1),:) = qbar(j-(nd-1),:)+pv(i,j,:)/float(imax)
      tbar(j-(nd-1),:) = tbar(j-(nd-1),:)+pt(i,j,:)/float(imax)
      ubar(j-(nd-1),:) = ubar(j-(nd-1),:)+uu(i,j,:)/float(imax)
    enddo
  enddo

  ! **** hemispheric-mean potential temperature ****
  tb(:) = tn0(:)

  do k = 2,kmax-1
    pv2(:,:) = pv(:,:,k)
    vort2(:,:) = vort(:,:,k)

    !  **** compute qref via area analysis ****
    qmax = maxval(pv2)
    qmin = minval(pv2)
    dq = (qmax-qmin)/float(nnd-1)
    qn(:) = 0.
    an(:) = 0.
    cn(:) = 0.
    do nn = 1,nnd
      qn(nn) = qmax - dq*float(nn-1)
    enddo
    do j = 1,jmax
      phi0 = -0.5*pi+dphi*float(j-1)
      do i = 1,imax
        ind = 1+int((qmax-pv2(i,j))/dq)
        da = a*a*dphi*dlambda*cos(phi0)
        an(ind) = an(ind) + da
        cn(ind) = cn(ind) + da*pv2(i,j)
      enddo
    enddo
    aan(1) = 0.
    ccn(1) = 0.
    do nn = 2,nnd
      aan(nn) = aan(nn-1)+an(nn)
      ccn(nn) = ccn(nn-1)+cn(nn)
    enddo
    do j = 1,nd-1
      do nn = 1,nnd-1
        if(aan(nn).le.alat(j).and.aan(nn+1).gt.alat(j)) then
          dd = (alat(j)-aan(nn))/(aan(nn+1)-aan(nn))
          qref(j,k) = qn(nn)*(1.-dd)+qn(nn+1)*dd
          cref(j,k) = ccn(nn)*(1.-dd)+ccn(nn+1)*dd
        endif
      enddo
    enddo

    qref(nd,k) = qmax

    cbar(nd,k) = 0.
    do j=nd-1,1,-1
      phi0 = dphi*(float(j)-0.5)
      cbar(j,k) = cbar(j+1,k)+0.5*(qbar(j+1,k)+qbar(j,k)) &
      *a*dphi*2.*pi*a*cos(phi0)
    enddo

    ! **** compute Kelvin's circulation based on absolute vorticity (for b.c.) ****


    qmax = maxval(vort2)
    qmin = minval(vort2)
    dq = (qmax-qmin)/float(nnd-1)
    qn(:) = 0.
    an(:) = 0.
    cn(:) = 0.
    do nn = 1,nnd
      qn(nn) = qmax - dq*float(nn-1)
    enddo
    do j = 1,jmax
      phi0 = -0.5*pi+dphi*float(j-1)
      do i = 1,imax
      ind = 1+int((qmax-vort2(i,j))/dq)
      da = a*a*dphi*dlambda*cos(phi0)
      an(ind) = an(ind) + da
      cn(ind) = cn(ind) + da*vort2(i,j)
      enddo
    enddo
    aan(1) = 0.
    ccn(1) = 0.
    do nn = 2,nnd
      aan(nn) = aan(nn-1)+an(nn)
      ccn(nn) = ccn(nn-1)+cn(nn)
    enddo
    do j = 1,nd-1
      do nn = 1,nnd-1
        if(aan(nn).le.alat(j).and.aan(nn+1).gt.alat(j)) then
          dd = (alat(j)-aan(nn))/(aan(nn+1)-aan(nn))
          ckref(j,k) = ccn(nn)*(1.-dd)+ccn(nn+1)*dd
        endif
      enddo
    enddo

  enddo

  ! ***** normalize QGPV by sine (latitude)  ****

  do j = 2,nd
    phi0 = dphi*float(j-1)
    cor = sin(phi0)
    qref(j,:) = qref(j,:)/cor
  enddo

  do k = 2,kmax-1
    qref(1,k) = 2.*qref(2,k)-qref(3,k)
  enddo

  ! ***** FAWA *****
  fawa(:,:) = (cref(:,:)-cbar(:,:))/(2.*pi*a)

  !  ***** Direct solver to invert Q_ref *****

  !  *** downward sweep ***

  ! **** top boundary condition (Eqs. 24-25) *****
  tjk(:,:) = 0.
  sjk(:,:,:) = 0.
  do jj = jb+2,(nd-1)
    j = jj-jb
    phi0 = float(jj-1)*dphi
    cos0 = cos(phi0)
    sin0 = sin(phi0)
    tjk(j-1,kmax-1) = -dz*rr*cos0*exp(-z(kmax-1)*rkappa/h)
    tjk(j-1,kmax-1) = tjk(j-1,kmax-1)*(tbar(j+1,kmax)-tbar(j-1,kmax))
    tjk(j-1,kmax-1) = tjk(j-1,kmax-1)/(4.*omega*sin0*dphi*h*a)
    sjk(j-1,j-1,kmax-1) = 1.
  enddo
END

SUBROUTINE matrix_b4_inversion(k,jmax,kmax,nd,jb,jd,z,statn,qref,ckref,sjk,&
        a, om, dz, h, rr, cp, &
        qjj,djj,cjj,rj)

  integer, INTENT(in) :: k, jmax, kmax, nd, jb, jd
  REAL, INTENT(in) :: z(kmax),statn(kmax),qref(nd,kmax),ckref(nd,kmax)
  REAL, INTENT(IN) :: sjk(jd-2,jd-2,kmax-1)
  REAL, INTENT(in) :: a, om, dz, h, rr, cp
  REAL, INTENT(OUT) :: qjj(jd-2,jd-2),djj(jd-2,jd-2),cjj(jd-2,jd-2),rj(jd-2)
  REAL :: xjj(jd-2,jd-2), u(jd,kmax)
  REAL :: sjj(jd-2,jd-2)

  rkappa = rr/cp
  pi = acos(-1.)
  dp = pi/float(jmax-1)

  zp = 0.5*(z(k+1)+z(k))
  zm = 0.5*(z(k-1)+z(k))
  statp = 0.5*(statn(k+1)+statn(k))
  statm = 0.5*(statn(k-1)+statn(k))
  cjj(:,:) = 0.
  djj(:,:) = 0.
  qjj(:,:) = 0.
  sjj(:,:) = sjk(:,:,k)
  do jj = jb+2,(nd-1)
    j = jj - jb
    phi0 = float(jj-1)*dp
    phip = (float(jj)-0.5)*dp
    phim = (float(jj)-1.5)*dp
    cos0 = cos(phi0)
    cosp = cos(phip)
    cosm = cos(phim)
    sin0 = sin(phi0)
    sinp = sin(phip)
    sinm = sin(phim)

    fact = 4.*om*om*h*a*a*sin0*dp*dp/(dz*dz*rr*cos0)
    amp = exp(-zp/h)*exp(rkappa*zp/h)/statp
    amp = amp*fact*exp(z(k)/h)
    amm = exp(-zm/h)*exp(rkappa*zm/h)/statm
    amm = amm*fact*exp(z(k)/h)

    ! ***** Specify A, B, C, D, E, F (Eqs. 4-9) *****
    ajk = 1./(sinp*cosp)
    bjk = 1./(sinm*cosm)
    cjk = amp
    djk = amm
    ejk = ajk+bjk+cjk+djk
    fjk = -0.5*a*dp*(qref(jj+1,k)-qref(jj-1,k))

    ! ***** Specify rk (Eq. 15) ****

    ! **** North-south boundary conditions ****
    u(jd,k) = 0.
    phi0 = dp*float(jb)
    !        u(1,k) = ubar(jb+1,k)*cos(phi0)
    u(1,k) = ckref(jb+1,k)/(2.*pi*a)-om*a*cos(phi0)

    rj(j-1) = fjk
    if(j.eq.2) rj(j-1) = fjk - bjk*u(1,k)
    if(j.eq.jd-1) rj(j-1) = fjk - ajk*u(jd,k)

    ! ***** Specify Ck & Dk (Eqs. 18-19) *****
    cjj(j-1,j-1) = cjk
    djj(j-1,j-1) = djk

    ! **** Specify Qk (Eq. 17) *****
    qjj(j-1,j-1) = -ejk
    if(j-1.ge.1.and.j-1.lt.jd-2) then
      qjj(j-1,j) = ajk
    endif
    if(j-1.gt.1.and.j-1.le.jd-2) then
      qjj(j-1,j-2) = bjk
    endif
  enddo

  ! **** Compute Qk + Ck Sk *******
  do i = 1,jd-2
    do j = 1,jd-2
      xjj(i,j) = 0.
      do kk = 1,jd-2
        xjj(i,j) = xjj(i,j)+cjj(i,kk)*sjj(kk,j)
      enddo
      qjj(i,j) = qjj(i,j)+xjj(i,j)
    enddo
  enddo

END SUBROUTINE matrix_b4_inversion

SUBROUTINE compute_reference_states(pv,uu,pt,stat,nlon,nlat,kmax,jd,npart,maxits,&
               a,om,dz,eps,h,dphi,dlambda,r,cp,rjac,qref,u,tref,num_of_iter)


    integer, intent(in) :: nlon,nlat,kmax,jd,npart,maxits
    real, intent(in) :: pv(nlon,nlat,kmax),uu(nlon,nlat,kmax),pt(nlon,nlat,kmax),stat(kmax)
    real, intent(in) :: a, om, dz,eps, h, dphi, dlambda, r, cp, rjac
    real, intent(out) :: qref(jd,kmax),u(jd,kmax),tref(jd,kmax)
    integer, intent(out) :: num_of_iter


    real :: pv2(nlon,nlat)
    real :: u2(nlon,nlat)
    real :: pt2(nlon,nlat)
    real :: qn(npart),an(npart),aan(npart),tb(kmax),tg(kmax)
    real :: cn(npart),ccn(npart)
    real :: alat(jd),phi(jd),z(kmax),cbar(jd,kmax)
    real :: ajk(jd,kmax),bjk(jd,kmax),cjk(jd,kmax)
    real :: djk(jd,kmax),ejk(jd,kmax),fjk(jd,kmax)

    real :: cref(jd,kmax)
    real :: qbar(jd,kmax),ubar(jd,kmax),tbar(jd,kmax)
    real :: pi, zero, half, qtr, one, rkappa

    pi = acos(-1.)
    !dphi = pi/float(nlat-1)
    !dlambda = 2*pi/float(nlon)
    zero = 0.
    half = 0.5
    qtr = 0.25
    one = 1.
    rkappa = r/cp        


    do nn = 1,jd
        phi(nn) = dphi*float(nn-1)
        alat(nn) = 2.*pi*a*a*(1.-sin(phi(nn)))
    enddo

    do k = 1,kmax
        z(k) = dz*float(k-1)
    enddo


    ! **** Zonal-mean field ****
    do j = jd,nlat 
        qbar(j-(jd-1),:) = 0.
        tbar(j-(jd-1),:) = 0.
        ubar(j-(jd-1),:) = 0.
        do i = 1,nlon
            qbar(j-(jd-1),:) = qbar(j-(jd-1),:)+pv(i,j,:)/float(nlon)
            tbar(j-(jd-1),:) = tbar(j-(jd-1),:)+pt(i,j,:)/float(nlon)
            ubar(j-(jd-1),:) = ubar(j-(jd-1),:)+uu(i,j,:)/float(nlon)
        enddo
    enddo

    ! **** hemispheric-mean potential temperature ****
    tb(:) = 0.
    wt = 0.
    do j = jd,nlat
        phi0 = dphi*float(j-1)-0.5*pi
        !tb(:) = tb(:)+cos(phi0)*tbar(j,:)
        tb(:) = tb(:)+cos(phi0)*tbar(j-(jd-1),:)
        wt = wt + cos(phi0)
    enddo
    tb(:) = tb(:)/wt

    do k = 2,KMAX-1
        pv2(:,:) = pv(:,:,k)    
        u2(:,:) = uu(:,:,k)    
        pt2(:,:) = pt(:,:,k)    

        !  **** area analysis ****
        qmax = maxval(pv2)
        qmin = minval(pv2)
        dq = (qmax-qmin)/float(npart-1)
        qn(:) = 0.
        an(:) = 0.
        cn(:) = 0.
        do nn = 1,npart
            qn(nn) = qmax - dq*float(nn-1)
        enddo            
        do j = 1,nlat
            phi0 = -0.5*pi+dphi*float(j-1)
            do i = 1,nlon
                ind = 1+int((qmax-pv2(i,j))/dq)
                da = a*a*dphi*dlambda*cos(phi0)
                an(ind) = an(ind) + da
                cn(ind) = cn(ind) + da*pv2(i,j)
            enddo
        enddo
        aan(1) = 0.
        ccn(1) = 0.
        do nn = 2,npart
            aan(nn) = aan(nn-1)+an(nn) 
            ccn(nn) = ccn(nn-1)+cn(nn) 
        enddo
        do j = 1,(jd-1)
            do nn = 1,npart-1
                if(aan(nn).le.alat(j).and.aan(nn+1).gt.alat(j)) then
                    dd = (alat(j)-aan(nn))/(aan(nn+1)-aan(nn))
                    qref(j,k) = qn(nn)*(1.-dd)+qn(nn+1)*dd
                    cref(j,k) = ccn(nn)*(1.-dd)+ccn(nn+1)*dd
                endif
            enddo 
        enddo

        qref(jd,k) = qmax

        cbar(jd,k) = 0.
        do j=(jd-1),1,-1
            phi0 = dphi*(float(j)-0.5)
            cbar(j,k) = cbar(j+1,k)+0.5*(qbar(j+1,k)+qbar(j,k)) &
            *a*dphi*2.*pi*a*cos(phi0)
        enddo 

    enddo


    ! ***** normalize QGPV by the Coriolis parameter ****

    do j = 2,jd
        phi0 = dphi*float(j-1)
        cor = 2.*om*sin(phi0)
        qref(j,:) = qref(j,:)/cor
    enddo

    do k = 2,KMAX-1
        qref(1,k) = 2.*qref(2,k)-qref(3,k)
    enddo


    ! **** SOR (elliptic solver a la Numerical Recipes) ****

    do j = 2,(jd-1)
        phi0 = float(j-1)*dphi
        phip = (float(j)-0.5)*dphi
        phim = (float(j)-1.5)*dphi
        cos0 = cos(phi0)
        cosp = cos(phip)
        cosm = cos(phim)
        sin0 = sin(phi0)
        sinp = sin(phip)
        sinm = sin(phim)
        do k = 2,KMAX-1
            zp = 0.5*(z(k+1)+z(k))
            zm = 0.5*(z(k-1)+z(k))
            statp = 0.5*(stat(k+1)+stat(k))
            statm = 0.5*(stat(k-1)+stat(k))
            fact = 4.*om*om*h*a*a*sin0*dphi*dphi/(dz*dz*r*cos0)
            amp = exp(-zp/h)*exp(rkappa*zp/h)/statp
            amp = amp*fact*exp(z(k)/h)
            amm = exp(-zm/h)*exp(rkappa*zm/h)/statm
            amm = amm*fact*exp(z(k)/h)
            ajk(j,k) = 1./(sinp*cosp)
            bjk(j,k) = 1./(sinm*cosm)
            cjk(j,k) = amp
            djk(j,k) = amm
            ejk(j,k) = -ajk(j,k)-bjk(j,k)-cjk(j,k)-djk(j,k)
            fjk(j,k) = -om*a*dphi*(qref(j+1,k)-qref(j-1,k))
        enddo
    enddo

    anormf = zero

    do j = 2,(jd-1)
        do k = 2,KMAX-1
            anormf = anormf + abs(fjk(j,k)) 
        enddo
    enddo

    omega = one

    do nnn = 1,maxits
        anorm = zero
        do j = 2,(jd-1)
            do k = 2,KMAX-1
                if(mod(j+k,2).eq.mod(nnn,2)) then
                    resid = ajk(j,k)*u(j+1,k)+bjk(j,k)*u(j-1,k)+    &
                     cjk(j,k)*u(j,k+1)+djk(j,k)*u(j,k-1)+    &
                     ejk(j,k)*u(j,k)-fjk(j,k)
                    anorm = anorm + abs(resid)
                    if(ejk(j,k).ne.0.) u(j,k) = u(j,k) - omega*resid/ejk(j,k)
                    if(ejk(j,k).eq.0.) u(j,k) = 0.
                endif
            enddo
            u(j,1) = 0.
            phi0 = dphi*float(j-1)
            uz = dz*r*cos(phi0)*exp(-z(KMAX-1)*rkappa/h)
            uz = uz*(tbar(j+1,KMAX-1)-tbar(j-1,KMAX-1))/(2.*om*sin(phi0)*dphi*h*a)
            u(j,KMAX) = u(j,KMAX-2)-uz
        enddo

        u(jd,:) = 0.
        u(1,:) = ubar(1,:)+(cref(1,:)-cbar(1,:))/(2.*pi*a)
        !        u(1,:) = ubar(1,:)

        if(nnn.eq.1) then
            omega = one/(one-half*rjac**2)
        else
            omega = one/(one-qtr*rjac**2*omega)
        endif

        if((nnn.gt.1).and.(anorm.lt.eps*anormf)) then
            if(nheck.eq.1) nheck = 0
            goto 233
        endif

    enddo

    ! **** In the case of non-convergence ****

    write(6,*) 'Maxits exceeded'

    u(:,:) = 0.      ! no correction for the non-converged case

    233  continue

    ! **** Converged! (u is the mass correction) ****

    write(6,*)  n,mm,kk,' converged at n = ',nnn
    num_of_iter = nnn

    do j = 2,(jd-1)
        phi0 = dphi*float(j-1)
        u(j,:) = u(j,:)/cos(phi0)
    enddo
    u(1,:) = ubar(1,:)
    u(jd,:) = 2.*u((jd-1),:)-u((jd-2),:)

    ! ******** compute tref *******

    do k = 2,KMAX-1
        t00 = 0.
        zz = dz*float(k-1)
        tref(1,k) = t00
        tref(2,k) = t00
        do j = 2,(jd-1)
            phi0 = dphi*float(j-1)
            cor = 2.*om*sin(phi0)  
            uz = (u(j,k+1)-u(j,k-1))/(2.*dz)
            ty = -cor*uz*a*h*exp(rkappa*zz/h)
            ty = ty/r
            tref(j+1,k) = tref(j-1,k)+2.*ty*dphi
        enddo
        tg(k) = 0.
        wt = 0.
        do j = 1,jd
            phi0 = dphi*float(j-1)
            tg(k) = tg(k)+cos(phi0)*tref(j,k)
            wt = wt + cos(phi0)
        enddo
        tg(k) = tg(k)/wt
        tres = tb(k)-tg(k)
        tref(:,k) = tref(:,k)+tres
    enddo
    tref(:,1) = tref(:,2)-tb(2)+tb(1)
    tref(:,KMAX) = tref(:,KMAX-1)-tb(KMAX-1)+tb(KMAX)


end subroutine

SUBROUTINE compute_lwa_only_nhn22(pv,uu,qref, &
        imax, JMAX, kmax, nd, jb, is_nhem, &
        a, om, dz, h, rr, cp, prefac, &
        astarbaro, ubaro, astar1, astar2)
  ! This was from compute_flux_dirinv.f90

  REAL, INTENT(IN) :: pv(imax,jmax,kmax),uu(imax,jmax,kmax),qref(nd,kmax)
  INTEGER, INTENT(IN) :: imax, JMAX, kmax, nd, jb
  LOGICAL, INTENT(IN) :: is_nhem
  REAL, INTENT(IN) :: a, om, dz, h, rr, cp, prefac
  REAL, INTENT(OUT) :: astarbaro(imax, nd), ubaro(imax, nd), astar1(imax,nd,kmax), astar2(imax,nd,kmax)

  REAL :: qe(imax,nd)
  REAL :: z(kmax)
  REAL :: aa, ab
  INTEGER :: jstart, jend

  pi = acos(-1.)
  dp = pi/float(jmax-1)
  rkappa = rr/cp

  ! *** Default values for boundary ***
  !jb = 5
  !jd = 86 ! nd - lower bounding latitude

  do k = 1,kmax
   z(k) = dz*float(k-1)
  enddo


! **** wave activity and nonlinear zonal flux F2 ****

  astarbaro(:,:) = 0.
  ubaro(:,:) = 0.
  dc = dz/prefac

  ! Bounds of y-indices in N/SHem
  if (is_nhem) then  ! 5N and higher latitude
    jstart = jb+1  ! 6
    jend = nd-1
  else
    jstart = 2
    jend = nd-jb   ! nd - 5
  endif

  do k = 2,kmax-1
    zk = dz*float(k-1)
    do i = 1,imax
      do j = jstart, jend
        astar1(i,j,k) = 0.       ! LWA*cos(phi)
        astar2(i,j,k) = 0.       ! LWA*cos(phi)
        if (is_nhem) then        !latitude
          phi0 = dp*float(j-1)
        else
          phi0 = dp*float(j-1)-0.5*pi
        endif
        cor = 2.*om*sin(phi0)          !Coriolis parameter
        ab = a*dp  !constant length element
        do jj = 1,nd
          if (is_nhem) then  ! Northern Hemisphere
            phi1 = dp*float(jj-1)
            qe(i,jj) = pv(i,jj+nd-1,k)-qref(j,k)    !qe; Q = qref
          else  ! Southern Hemisphere
            phi1 = dp*float(jj-1)-0.5*pi
            qe(i,jj) = pv(i,jj,k)-qref(j,k)     !qe; Q = qref
          endif
          aa = a*dp*cos(phi1)   !cosine factor in the meridional integral
          if((qe(i,jj).le.0.).and.(jj.ge.j)) then  !LWA*cos and F2
            if (is_nhem) then  ! Northern Hemisphere
              astar2(i,j,k)=astar2(i,j,k)-qe(i,jj)*aa  !anticyclonic
            else  ! Southern Hemisphere
              astar1(i,j,k)=astar1(i,j,k)-qe(i,jj)*aa  !cyclonic
            endif
          endif
          if((qe(i,jj).gt.0.).and.(jj.lt.j)) then
            if (is_nhem) then  ! Northern Hemisphere
              astar1(i,j,k)=astar1(i,j,k)+qe(i,jj)*aa  !cyclonic
            else  ! Southern Hemisphere
              astar2(i,j,k)=astar2(i,j,k)+qe(i,jj)*aa  !anticyclonic
            endif
          endif
        enddo

      enddo
      phip = dp*jb
      phi0 = dp*(jb-1)
      cosp = cos(phip)          ! cosine for one grid north
      cos0 = cos(phi0)          ! cosine for latitude grid
    enddo

    ! ******** Column average: (25) of SI-HN17 ********

    astarbaro(:,:) = astarbaro(:,:)+(astar1(:,:,k)    &
    + astar2(:,:,k))*exp(-zk/h)*dc

    if (is_nhem) then
      do j = jstart,jend
        ubaro(:,j) = ubaro(:,j)+uu(:,nd-1+j,k)*exp(-zk/h)*dc
      enddo
    else
      do j = jstart,jend
        ubaro(:,j) = ubaro(:,j)+uu(:,j,k)*exp(-zk/h)*dc
      enddo
    endif
  enddo

END SUBROUTINE

SUBROUTINE interpolate_fields_direct_inv(nlon, nlat, nlev, kmax, jd, uu, vv, tt, plev, &
        aa, omega, dz, hh, rr, cp, &
        pv, uq, vq, avort, tq, statn, stats, tn0, ts0)


  INTEGER, INTENT(IN) :: nlon, nlat, nlev, kmax, jd
  REAL, INTENT(IN) :: uu(nlon,nlat,nlev), vv(nlon,nlat,nlev), tt(nlon,nlat,nlev), &
            plev(nlev)
  REAL, INTENT(in) :: aa, omega, dz,hh, rr, cp
  REAL, INTENT(out) :: pv(nlon,nlat,kmax), uq(nlon,nlat,kmax), vq(nlon,nlat,kmax), avort(nlon,nlat,kmax)
  REAL, INTENT(out) :: tq(nlon,nlat,kmax), statn(kmax), stats(kmax), tn0(kmax), ts0(kmax)

   real ::  tzd(nlat,kmax)
   real ::  height(kmax)
   real ::  zlev(nlev)
   real ::  st(nlon,nlat),zmst(nlat)
   real ::  zmav(nlat,kmax)
   real ::  zmpv(nlat,kmax)
   integer :: k0(kmax),kp(kmax)
   real :: dd2(kmax),dd1(kmax),pks(kmax)

   rkappa = rr/cp
   pi = acos(-1.)
   dphi = pi/float(nlat-1)

  write(6,*) 'nlon, nlat, nlev, kmax, jd'
  write(6,*) nlon, nlat, nlev, kmax, jd

! ====== Assign pseudoheight =====

  do k = 1,nlev
    zlev(k) = -hh*alog(plev(k)/1000.)
  enddo

  do k = 1,kmax
    height(k) = float(k-1)*dz
    pks(k) = exp(rkappa*height(k)/hh)
  enddo


  do kk = 2,kmax   ! vertical interpolation
    ttt = height(kk)
    do k = 1,nlev-1
      tt2 = zlev(k+1)
      tt1 = zlev(k)
      if((ttt.ge.tt1).and.(ttt.lt.tt2)) then
        k0(kk) = k
        kp(kk) = k+1
        dd1(kk) = (ttt-tt1)/(tt2-tt1)
        dd2(kk) = 1.-dd1(kk)
      endif
    enddo
  enddo

! ====  vertical interpolation ====

  do i = 1,nlon
    do j = 1,nlat

      st(i,j) = tt(i,j,1)      ! surface pot. temp

      do kk = 2,kmax   ! vertical interpolation
        uq(i,j,kk) = uu(i,j,k0(kk))*dd2(kk) + uu(i,j,kp(kk))*dd1(kk)
        vq(i,j,kk) = vv(i,j,k0(kk))*dd2(kk) + vv(i,j,kp(kk))*dd1(kk)
        !     wq(i,j,kk) = ww(i,j,k0(kk))*dd2(kk) + ww(i,j,kp(kk))*dd1(kk)
        tq(i,j,kk) = tt(i,j,k0(kk))*dd2(kk) + tt(i,j,kp(kk))*dd1(kk)
        tq(i,j,kk) = tq(i,j,kk)*pks(kk)  ! potential temperature
        !     zq(i,j,kk) = zz(i,j,k0(kk))*dd2(kk) + zz(i,j,kp(kk))*dd1(kk)
      enddo

      tq(i,j,1) = tt(i,j,1)
      uq(i,j,1) = uu(i,j,1)
      vq(i,j,1) = vv(i,j,1)
      !     wq(i,j,1) = ww(i,j,1)
      !     zq(i,j,1) = zz(i,j,1)
    enddo
  enddo

!  **** compute zonal mean ****

  tzd = 0.

  do j = 1,nlat
    do k = 1,kmax
      do i = 1,nlon
        tzd(j,k) = tzd(j,k) + tq(i,j,k)/float(nlon)
      enddo
    enddo
  enddo


  ! reference theta
  do kk = 1,kmax
    ts0(kk) = 0.
    tn0(kk) = 0.
    csm = 0.
    cnm = 0.
    do j = 1,jd
      phi0 = -0.5*pi + pi*float(j-1)/float(nlat-1)
      ts0(kk) = ts0(kk) + tzd(j,kk)*cos(phi0)
      csm = csm + cos(phi0)
    enddo
    ts0(kk) = ts0(kk)/csm
    do j = jd,nlat
      phi0 = -0.5*pi + pi*float(j-1)/float(nlat-1)
      tn0(kk) = tn0(kk) + tzd(j,kk)*cos(phi0)
      cnm = cnm + cos(phi0)
    enddo
    tn0(kk) = tn0(kk)/cnm
  enddo

  ! static stability
  do kk = 2,kmax-1
    stats(kk) = (ts0(kk+1)-ts0(kk-1))/(height(kk+1)-height(kk-1))
    statn(kk) = (tn0(kk+1)-tn0(kk-1))/(height(kk+1)-height(kk-1))
  enddo
  stats(kmax) = 2.*stats(kmax-1)-stats(kmax-2)
  statn(kmax) = 2.*statn(kmax-1)-statn(kmax-2)
  stats(1) = 2.*stats(2)-stats(3)
  statn(1) = 2.*statn(2)-statn(3)

  ! surface temp

  do j = 1,nlat
    zmst(j) = 0.
    do i = 1,nlon
      zmst(j) = zmst(j) + st(i,j)/float(nlon)
    enddo
  enddo

! interior abs. vort

  do kk = 1,kmax
    do j = 2,nlat-1
      phi0 = -0.5*pi + pi*float(j-1)/float(nlat-1)
      phim = -0.5*pi + pi*float(j-2)/float(nlat-1)
      phip = -0.5*pi + pi*float(j)/float(nlat-1)

      do i = 2,nlon-1
        av1 = 2.*omega*sin(phi0)
        av2 = (vq(i+1,j,kk)-vq(i-1,j,kk))/(2.*aa*cos(phi0)*dphi)
        av3 = -(uq(i,j+1,kk)*cos(phip)-uq(i,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
        avort(i,j,kk) = av1+av2+av3
      enddo

      av1 = 2.*omega*sin(phi0)
      av2 = (vq(2,j,kk)-vq(nlon,j,kk))/(2.*aa*cos(phi0)*dphi)
      av3 = -(uq(1,j+1,kk)*cos(phip)-uq(1,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
      avort(1,j,kk) = av1+av2+av3
      av4 = 2.*omega*sin(phi0)
      av5 = (vq(1,j,kk)-vq(nlon-1,j,kk))/(2.*aa*cos(phi0)*dphi)
      av6 =   &
      -(uq(nlon,j+1,kk)*cos(phip)-uq(nlon,j-1,kk)*cos(phim))/(2.*aa*cos(phi0)*dphi)
      avort(nlon,j,kk) = av4+av5+av6
    enddo

    avs = 0.
    avn = 0.
    do i = 1,nlon
      avs = avs + avort(i,2,kk)/float(nlon)
      avn = avn + avort(i,nlat-1,kk)/float(nlon)
    enddo
    avort(:,1,kk) = avs
    avort(:,nlat,kk) = avn
  enddo

  ! zonal mean vort

  do kk = 1,kmax
    do j = 1,nlat
      zmav(j,kk) = 0.
      do i = 1,nlon
        zmav(j,kk) = zmav(j,kk)+avort(i,j,kk)/float(nlon)
      enddo
    enddo
  enddo

  ! interior pv

  do kk = 2,kmax-1
    do j = 1,nlat
      phi0 = -0.5*pi + pi*float(j-1)/float(nlat-1)
      f = 2.*omega*sin(phi0)
      if (j .le. jd) then
        statp = stats(kk+1)
        statm = stats(kk-1)
        t00p = ts0(kk+1)
        t00m = ts0(kk-1)
      else
        statp = statn(kk+1)
        statm = statn(kk-1)
        t00p = tn0(kk+1)
        t00m = tn0(kk-1)
      endif

      do i = 1,nlon
        thetap = tq(i,j,kk+1)
        thetam = tq(i,j,kk-1)
        altp = exp(-height(kk+1)/hh)*(thetap-t00p)/statp
        altm = exp(-height(kk-1)/hh)*(thetam-t00m)/statm
        strc = (altp-altm)*f/(height(kk+1)-height(kk-1))
        pv(i,j,kk) = avort(i,j,kk) + exp(height(kk)/hh)*strc
      enddo
    enddo
  enddo

! zonal mean pv

  do kk = 1,kmax
    do j = 1,nlat
      zmpv(j,kk) = 0.
      do i = 1,nlon
        zmpv(j,kk) = zmpv(j,kk)+pv(i,j,kk)/float(nlon)
      enddo
    enddo
  enddo
END SUBROUTINE

SUBROUTINE compute_flux_dirinv_nshem(pv,uu,vv,pt,tn0,qref,uref,tref,&
        imax, JMAX, kmax, nd, jb, jd, is_nhem, &
        a, om, dz, h, rr, cp, prefac,&
        astarbaro,ubaro,urefbaro,ua1baro,ua2baro,ep1baro,ep2baro,ep3baro,ep4,astar1,astar2)

  REAL, INTENT(IN) :: pv(imax,jmax,kmax),uu(imax,jmax,kmax),vv(imax,jmax,kmax),pt(imax,jmax,kmax),&
          tn0(kmax),qref(nd,kmax),uref(jd,kmax),tref(jd,kmax)
  INTEGER, INTENT(IN) :: imax, JMAX, kmax, nd, jb, jd
  LOGICAL, INTENT(IN) :: is_nhem
  REAL, INTENT(IN) :: a, om, dz, h, rr, cp, prefac
  REAL, INTENT(OUT) :: astarbaro(imax,nd),ubaro(imax,nd),urefbaro(nd),ua1baro(imax,nd),ua2baro(imax,nd),&
          ep1baro(imax,nd),ep2baro(imax,nd),ep3baro(imax,nd),ep4(imax,nd),astar1(imax,nd,kmax),astar2(imax,nd,kmax)

  REAL :: tg(kmax),ua1(imax,nd),ua2(imax,nd),ep1(imax,nd),ep2(imax,nd),ep3(imax,nd)
  REAL :: qe(imax,nd),ue(imax,nd)
  REAL :: z(kmax)
  REAL :: aa, ab
  INTEGER :: jstart, jend

  !a = 6378000.
  pi = acos(-1.)
  !om = 7.29e-5
  dp = pi/float(jmax-1)
  !dz = 500.
  !h = 7000.
  !r = 287.
  rkappa = rr/cp
  !prefac = 6745.348

  ! *** Default values for boundary ***
  !jb = 5
  !jd = 86 ! nd - lower bounding latitude

  do k = 1,kmax
   z(k) = dz*float(k-1)
  enddo


! **** hemispheric-mean potential temperature ****
  tg(:) = tn0(:)

! **** wave activity and nonlinear zonal flux F2 ****

  astarbaro(:,:) = 0.
  ubaro(:,:) = 0.
  urefbaro(:) = 0.
  ua1baro(:,:) = 0.
  ua2baro(:,:) = 0.
  ep1baro(:,:) = 0.
  ep2baro(:,:) = 0.
  ep3baro(:,:) = 0.
  ep4(:,:) = 0.
  dc = dz/prefac

  ! Bounds of y-indices in N/SHem
  if (is_nhem) then  ! 5N and higher latitude
    jstart = jb+1  ! 6
    jend = nd-1
  else
    jstart = 2
    jend = nd-jb   ! nd - 5
  endif

  do k = 2,kmax-1
    zk = dz*float(k-1)
    do i = 1,imax
      do j = jstart, jend
        astar1(i,j,k) = 0.       ! LWA*cos(phi)
        astar2(i,j,k) = 0.       ! LWA*cos(phi)
        ua2(i,j) = 0.          !F2
        if (is_nhem) then        !latitude
          phi0 = dp*float(j-1)
        else
          phi0 = dp*float(j-1)-0.5*pi
        endif
        cor = 2.*om*sin(phi0)          !Coriolis parameter
        ab = a*dp  !constant length element
        do jj = 1,nd
          if (is_nhem) then  ! Northern Hemisphere
            phi1 = dp*float(jj-1)
            qe(i,jj) = pv(i,jj+nd-1,k)-qref(j,k)    !qe; Q = qref
            ue(i,jj) = uu(i,jj+nd-1,k)*cos(phi0)-uref(j-jb,k)*cos(phi1) !ue; shift uref 5N
          else  ! Southern Hemisphere
            phi1 = dp*float(jj-1)-0.5*pi
            qe(i,jj) = pv(i,jj,k)-qref(j,k)     !qe; Q = qref
            ue(i,jj) = uu(i,jj,k)*cos(phi0)-uref(j,k)*cos(phi1)  !ue;
          endif
          aa = a*dp*cos(phi1)   !cosine factor in the meridional integral
          if((qe(i,jj).le.0.).and.(jj.ge.j)) then  !LWA*cos and F2
            if (is_nhem) then  ! Northern Hemisphere
              astar2(i,j,k)=astar2(i,j,k)-qe(i,jj)*aa  !anticyclonic
            else  ! Southern Hemisphere
              astar1(i,j,k)=astar1(i,j,k)-qe(i,jj)*aa  !cyclonic
            endif
            ua2(i,j) = ua2(i,j)-qe(i,jj)*ue(i,jj)*ab
          endif
          if((qe(i,jj).gt.0.).and.(jj.lt.j)) then
            if (is_nhem) then  ! Northern Hemisphere
              astar1(i,j,k)=astar1(i,j,k)+qe(i,jj)*aa  !cyclonic
            else  ! Southern Hemisphere
              astar2(i,j,k)=astar2(i,j,k)+qe(i,jj)*aa  !anticyclonic
            endif
            ua2(i,j) = ua2(i,j)+qe(i,jj)*ue(i,jj)*ab
          endif
        enddo

        !  ******** Other fluxes ******
        if (is_nhem) then
          ua1(i,j) = uref(j-jb,k)*(astar1(i,j,k) + astar2(i,j,k))  !F1
          ep1(i,j) = -0.5*(uu(i,j+nd-1,k)-uref(j-jb,k))**2         !F3a
          ep1(i,j) = ep1(i,j)+0.5*vv(i,j+nd-1,k)**2                !F3a+b
          ep11 = 0.5*(pt(i,j+nd-1,k)-tref(j-jb,k))**2              !F3c
        else
          ua1(i,j) = uref(j,k)*(astar1(i,j,k) + astar2(i,j,k))     !F1
          ep1(i,j) = -0.5*(uu(i,j,k)-uref(j,k))**2                 !F3a
          ep1(i,j) = ep1(i,j)+0.5*vv(i,j,k)**2                     !F3a+b
          ep11 = 0.5*(pt(i,j,k)-tref(j,k))**2               !F3c
        endif
        zz = dz*float(k-1)
        ep11 = ep11*(rr/h)*exp(-rkappa*zz/h)
        ep11 = ep11*2.*dz/(tg(k+1)-tg(k-1))
        ep1(i,j) = ep1(i,j)-ep11                   !F3
        if (is_nhem) then
          phip = dp*float(j)
          phi0 = dp*float(j-1)
          phim = dp*float(j-2)
        else
          phip = dp*float(j) - 0.5*pi
          phi0 = dp*float(j-1) - 0.5*pi
          phim = dp*float(j-2) - 0.5*pi
        endif
        cosp = cos(phip)          ! cosine for one grid north
        cos0 = cos(phi0)          ! cosine for latitude grid
        cosm = cos(phim)          ! cosine for one grid south
        sin0 = sin(phi0)          ! sine for latitude grid
        ep1(i,j) = ep1(i,j)*cos0 ! correct for cosine factor


        ! meridional eddy momentum flux one grid north and south
        if (is_nhem) then
          ep2(i,j) = (uu(i,j+nd,k)-uref(j-jb+1,k))*cosp*cosp * vv(i,j+nd,k)
          ep3(i,j) = (uu(i,j+nd-2,k)-uref(j-jb-1,k))*cosm*cosm * vv(i,j+nd-2,k)
        else
          ! TODO: double check.
          ep2(i,j) = (uu(i,j+1,k)-uref(j+1,k))*cosp*cosp * vv(i,j+1,k)
          ep3(i,j) = (uu(i,j-1,k)-uref(j-1,k))*cosm*cosm * vv(i,j-1,k)
        endif

        ! low-level meridional eddy heat flux
        if(k.eq.2) then     ! (26) of SI-HN17
          ep41 = 2.*om*sin0*cos0*dz/prefac       ! prefactor
          if (is_nhem) then
            ep42 = exp(-dz/h)*vv(i,j+nd-1,2)*(pt(i,j+nd-1,2)-tref(j-jb,2))/(tg(3)-tg(1))
            ep43 = vv(i,j+nd-1,1)*(pt(i,j+nd-1,1)-tref(j-jb,1))
          else
            ep42 = exp(-dz/h)*vv(i,j,2)*(pt(i,j,2)-tref(j,2))/(tg(3)-tg(1))
            ep43 = vv(i,j,1)*(pt(i,j,1)-tref(j,1))
          endif
          ep43 = 0.5*ep43/(tg(2)-tg(1))
          ep4(i,j) = ep41*(ep42+ep43)   ! low-level heat flux
        endif
      enddo
      phip = dp*jb
      phi0 = dp*(jb-1)
      cosp = cos(phip)          ! cosine for one grid north
      cos0 = cos(phi0)          ! cosine for latitude grid
      ep2(i,jb) = (uu(i,nd+jb+1,k)-uref(2,k))*cosp*cosp*vv(i,nd+jb+1,k)
      ep3(i,jb) = (uu(i,nd+jb,k)-uref(1,k))*cos0*cos0*vv(i,nd+jb,k)
    enddo

    ! ******** Column average: (25) of SI-HN17 ********

    astarbaro(:,:) = astarbaro(:,:)+(astar1(:,:,k)    &
    + astar2(:,:,k))*exp(-zk/h)*dc
    ua1baro(:,:) = ua1baro(:,:)+ua1(:,:)*exp(-zk/h)*dc
    ua2baro(:,:) = ua2baro(:,:)+ua2(:,:)*exp(-zk/h)*dc
    ep1baro(:,:) = ep1baro(:,:)+ep1(:,:)*exp(-zk/h)*dc
    ep2baro(:,:) = ep2baro(:,:)+ep2(:,:)*exp(-zk/h)*dc
    ep3baro(:,:) = ep3baro(:,:)+ep3(:,:)*exp(-zk/h)*dc

    if (is_nhem) then
      do j = jstart,jend
        ubaro(:,j) = ubaro(:,j)+uu(:,nd-1+j,k)*exp(-zk/h)*dc
        urefbaro(j) = urefbaro(j)+uref(j-jb,k)*exp(-zk/h)*dc
      enddo
    else
      do j = jstart,jend
        ubaro(:,j) = ubaro(:,j)+uu(:,j,k)*exp(-zk/h)*dc
        urefbaro(j) = urefbaro(j)+uref(j,k)*exp(-zk/h)*dc
      enddo
    endif
  enddo

END SUBROUTINE
